local addon, shared = ...

local STRINGSUB = string.sub
local STRINGFORMAT = string.format
local STRINGUPPER = string.upper
local STRINGLOWER = string.lower
local STRINGFIND = string.find

_POPUPITEMS = { UI={} }

local PI = _POPUPITEMS

PI.MENUSTACK = {}
PI.BUTTONSTATE = {}

local function MergeTable(o,n)
	for k,v in pairs(n) do
		if type(v) == "table" then
			if o[k] == nil then
				o[k] = {}
			end
	 	 	if type(o[k]) == 'table' then
	 			MergeTable(o[k], n[k])
	 	 	end
		else
			if o[k] == nil then
				o[k] = v
			end
		end
	end
end

local PI_NONE	=0
local PI_ITEM	=1
local PI_MENU	=2
local PI_ISET	=3

local PIT_NORMAL	=1
local PIT_QUEST		=2
local PIT_CONSUME	=3

local CURRENT_PAGE = nil
local cursel = 0
local coroDead = false

local QSTITEMKEY = {}
local qstcrntpage= 0

local CFG_CURITEM = {}
local CFG_CURPAGE = ""
local CFG_CURPSEL = 0
local CFG_BTNSTATUS = {}
local DD_ISET = {}
local DD_PAGE = {}
local DD_PAGESEL={}
local CFG_WIPPAGE = {}
local WIP_CHANGE = false

PI.QUEST_DETAILS = {
	zone = nil,
	items = {}
}

local WIP_ACTIVE = false

local _itemdetails = {}
local _registereditems = {}
local _cpitems = {}
local _allcooldowns = {}
local CDACTIVE = false

local default_settings = {
	config = { ic=64, cfgx=200, cfgy=200, version = addon.toc.Version },
	ITEM_SETS = {
		["QUEST_ITEMS"] = {
			delete = false,
			items = {
				-- Ashora dailies
				{id = "IFD2F98F2EF41E4EE,668651B02875030E,,,,,,", n = "Qaijiri Fertilizer", z = "z2F1E4708BEC6A608", i="item_icons\\dust8.dds"},
				{id = "IFA0F128ACCB60098,E80C988CCFCD1035,,,,,,", n = "Qaijiri Thirst Salve", z = "z2F1E4708BEC6A608", i="item_icons\\salve_6b.dds"},
				{id = "IFD558603B6F66C8F,48357615D225361D,,,,,,", n = "Snake-Sack", z = "z2F1E4708BEC6A608", i="item_icons\\sack_of_coins.dds"},
				-- Ashora zone events
				-- Steppes dailies
				{id = "IFB0AB3564B97A3A3,E5BF5401B06056F5,,,,,,", n = "Embodied Flame", z = "z2F9C9E1FF91F9293", i="item_icons\\fatestone_01_red_a.dds"},
				{id = "IFB86F34AADC3C087,BFBD7C3636663F2A,,,,,,", n = "Corporealizer", z = "z2F9C9E1FF91F9293", i="item_icons\\fatestone_04_frag_1_lavender_a.dds"},		
				-- Steppes zone Events
				{id = "I6D6DA5C3966A8B04,2415F08340368691,,,,,,", n = "Wand of Scattering", z = "z2F9C9E1FF91F9293", i="item_icons\\ranged_wand_027a.dds"},
				{id = "I5A7785ED6CE5D903,F2169F93DEEE51C1,,,,,,", n = "Televeyer", z = "z2F9C9E1FF91F9293", i="ability_icons\\generic_ability_030_a.dds"},
			}
		},	
		["Heal Potions"] = {
			delete = true,
			items = {
				{id="IFE833A28949EC4A4,EBA242F8DDE617E6,,,,,,", n="Stellar Healing Potion", i="item_icons\\major_potion_rectangular_1.dds"}, -- 53,
				{id="I02FABDA76058C889,F2AD4C979E8C847E,,,,,,", n="Glorified Healing Potion", i="item_icons\\major_potion_spherical_1.dds"}, -- 50,
				{id="IFE833A27590B0FFB,E491EA0C5DE5450A,,,,,,", n="Excellent Healing Potion", i="item_icons\\greater_potion_cylindrical_1.dds"}, -- 51,
			}
		},
		["Heal Tonics"] = {
			delete = true,
			items = {
				{id="IFF8263537ABAD479,1AFA251C0FAAB793,,,,,,", n="Stellar Healing Tonic", i="item_icons\\powerful_potion_cylindrical_1.dds"}, -- 53,
			}
		},
		["Mana Potions"] = {
			delete = true,
			items = {
				{id="IFEB31F35E122C825,047D76BD1F0DB015,,,,,,", n="Stellar Mana Potion", i="item_icons\\major_potion_rectangular_6.dds"},
				{id="IFEB31F34AFE70218,727B1FA713B0E8EC,,,,,,", n="Excellent Mana Potion", i="item_icons\\greater_potion_cylindrical_6.dds"},
				{id="I04081FE6CFFCEDF9,4304E2B98E55DE02,,,,,,", n="Mighty Mana Potion", i="item_icons\\heroic_potion_cylindrical_6.dds"},
				{id="I2B1702446683F581,E632C8348F7FDF75,,,,,,", n="Greater Mana Potion", i="item_icons\\legendary_potion_cylindrical_6.dds"},
				{id="I33C603CA75F68664,094625D9A91CCA2E,,,,,,", n="Basic Mana Potion", i="item_icons\\greater_potion_spherical_6.dds"},
				{id="I33D57B44B57B933B,1D50816D216C3A97,,,,,,", n="Mana Potion", i="item_icons\\medium_potion_cylindrical_6.dds"},
				{id="I54BA72CCB749E0F9,58F866EFCD273C64,,,,,,", n="Minor Mana Potion", i="item_icons\\minor_potion_spherical_6.dds"},
				{id="I4B4192907292B320,322B35C4DDC56CCE,,,,,,", n="Lesser Mana Potion", i="item_icons\\minor_potion_cylindrical_6.dds"},
			}
		},
		["Mana Tonics"] = {
			delete = true,
			items = {
				{id="IFE41287A8CE602FB,28BD95CE0E45C26B,,,,,,", n="Stellar Mana Tonic", i="item_icons\\powerful_potion_cylindrical_6.dds"},
			}
		},
		["Vendor Drink"] = {
			delete = true,
			items = {
				{id="IFBC166EA9EFED8F7,0F57403A2799C1A5,,,,,,", n="Torvan Stout", i="item_icons\\mug2.dds"},
				{id="IFF69C4606ADB8964,33852557E69581AA,,,,,,", n="Qaijiri Grog", i="item_icons\\mechanical_bottle.dds"},
				{id="IFF0F7997C36748E8,236789CD030BC81B,,,,,,", n="Brevanic Tea", i="item_icons\\wine_bottle2_c.dds"},
				{id="IFD6683E4C858B1A6,DAB7B910159C1B74,,,,,,", n="Dusken Dark Roast", i="item_icons\\cup.dds"},
				{id="I201C8776C24A8C3F,7BC68A1BAE4D3032,,,,,,", n="Isle Embrosia", i="item_icons\\wine_bottle_a.dds"},
				{id="I2D44ECB584B4F695,04D72D194948627F,,,,,,", n="Ironpine Melange", i="item_icons\\rogue_potion.dds"},
				{id="I661A1744758DA794,6E03176411B9A879,,,,,,", n="Blood Rum", i="item_icons\\mug5.dds"},
				{id="I75FFBCCFD5D471A6,EB3E5A3CDDDAC21B,,,,,,", n="Dwarven Ale", i="item_icons\\mug_07.dds"}
			}
		},
		["PLANAR WATER"] = {
			delete = true,
			items = {
				{id="IFB3BCF8F571BE593,092899BBEBCCEB3C,,,,,,", n="Archaic Tablet", i="item_icons\\rift_consumable_water_05.dds"}, -- 50,
				{id="I191FF67A26CD2E6B,13215559F6CC66E2,,,,,,", n="Elder Tablet", i="item_icons\\rift_consumable_water_05.dds"}, -- 38,
				{id="I000EC535006CA2B9,DBC38C6822EEE0B7,,,,,,", n="Ageless Tablet", i="item_icons\\rift_consumable_water_03_a.dds"}, -- 28,
			}
		},
		["PLANAR EARTH"] = {
			delete = true,
			items = {
				{id="IFF10ACB870D566AC,0C22511C9006220D,,,,,,", n="Petrified Rune", i="item_icons\\rift_consumable_earth_05.dds"}, -- 50,
				{id="IFFF129C11C434D3A,25111EAB14AB417A,,,,,,", n="Igneous Rune", i="item_icons\\rift_consumable_earth_04.dds"}, -- 38,
				{id="IFF1E56375EBD168B,0F0DBD9962BD91D7,,,,,,", n="Geotic Rune", i="item_icons\\rift_consumable_earth_03.dds"}, -- 28,
				{id="IFBD7F5424ED75F03,402F79554F117054,,,,,,", n="Stone Rune", i="item_icons\\rift_consumable_earth_02_a.dds"}, -- 0,
			}
		},
		["PLANAR AIR"] = {
			delete = true,
			items = {
				{id="IFCB65A908FFE6573,36666BA16F7EBA98,,,,,,", n="Charged Mirror", i="item_icons\\rift_consumable_air_05.dds"}, -- 50,
				{id="IFE7F82431C9F6766,2BEBC136F3E2EA8D,,,,,,", n="Tempest Mirror", i="item_icons\\rift_consumable_air_05.dds"}, -- 38,
				{id="IFA3BA15404DDB011,DD1C6BC59CF6A149,,,,,,", n="Storm Mirror", i="item_icons\\rift_consumable_air_03_a.dds"}, -- 28,
			}
		},
		["PLANAR FIRE"] = {
			delete = true,
			items = {
				{id="IFDCBA1574384D472,C9AB7C391AF7A68A,,,,,,", n="Consuming Flame", i="item_icons\\rift_consumable_fire_05.dds"}, -- 50,
				{id="I710DA475326567BA,6918E3F8D6043C81,,,,,,", n="Wrathful Flame", i="item_icons\\rift_consumable_fire_05.dds"}, -- 38,
				{id="I30ED707E758D8609,65D87F93B901A98F,,,,,,", n="Needling Flame", i="item_icons\\rift_consumable_fire_02.dds"}, -- 18,
			}
		},
		["PLANAR DEATH"] = {
			delete = true,
			items = {
				{id="IFFB3E82CD044976B,3107D48A3F0974CF,,,,,,", n="Soul Crystal", i="item_icons\\rift_consumable_death_05.dds"}, -- 50,
				{id="I1F223D153260859C,1661B2746C2FF5E5,,,,,,", n="Soul Remnant", i="item_icons\\rift_consumable_death_05.dds"}, -- 38,
				{id="I55A76BFB39AC3C21,18B2F7C0BF907FDF,,,,,,", n="Soul Fragment", i="item_icons\\rift_consumable_death_03.dds"}, -- 28,
				{id="I207EAE17667BBD11,D54BB678A4D099A7,,,,,,", n="Soul Sliver", i="item_icons\\rift_consumable_death_02.dds"}, -- 0,
			}
		},
		["PLANAR LIFE"] = {
			delete = true,
			items = {
				{id="IFE13C4BAC6064857,F097C43325728132,,,,,,", n="Renewing Seed", i="item_icons\\rift_consumable_life_05.dds"}, -- 50,
				{id="I399232120EFACFE6,05847D171BD322C3,,,,,,", n="Revitalization Seed", i="item_icons\\rift_consumable_life_05.dds"}, -- 38,
				{id="I2FB014C8626637EA,ABD8D833356C518A,,,,,,", n="Restoration Seed", i="item_icons\\rift_consumable_life_03.dds"}, -- 28,
			}
		},
	},
	PAGES = {
		["DEFAULT"] = {
			delete = false,
			type = PIT_NORMAL,
			slots = {
				[2] = { t=PI_NONE },
				[3] = { t=PI_MENU, n="QUEST", l="Quest"},
				[4] = { t=PI_NONE },
				[5] = { t=PI_NONE },
				[6] = { t=PI_NONE },
				[7] = { t=PI_MENU, n="PLANARCONSUMABLES", l="Planar\nConsum."},
				[8] = { t=PI_NONE },
				[9] = { t=PI_MENU, n="CONSUMABLES", l="Cons"}
			}
		},
		["QUEST"] = {
			delete = false,
			type = PIT_QUEST,
			page=1,
			pagecnt=1
		},
		["PLANARCONSUMABLES"] = {
			delete = true,
			type = PIT_NORMAL,
			slots = {
				[2] = { t=PI_ISET, n="PLANAR EARTH"},
				[3] = { t=PI_ISET, n="PLANAR AIR"},
				[4] = { t=PI_ISET, n="PLANAR FIRE"},
				[5] = { t=PI_NONE },
				[6] = { t=PI_NONE },
				[7] = { t=PI_ISET, n="PLANAR WATER"},
				[8] = { t=PI_ISET, n="PLANAR LIFE"},
				[9] = { t=PI_ISET, n="PLANAR DEATH"},
			}
		},
		["CONSUMABLES"] = {
			type = PIT_NORMAL,
			delete = true,
			slots = {
				[2] = { t=PI_ISET, n="Heal Potions"},
				[3] = { t=PI_NONE },
				[4] = { t=PI_ISET, n="Mana Potions"},
				[5] = { t=PI_ISET, n="Heal Tonics"},
				[6] = { t=PI_ISET, n="Mana Tonics"},
				[7] = { t=PI_NONE },
				[8] = { t=PI_ISET, n="Vendor Drink"},
				[9] = { t=PI_NONE },
			}
		}
	}
}

local function mk_texture(n,c,w,h,l,a)
	local f = UI.CreateFrame("Texture", n,c)
	if w then f:SetWidth(w) end
	if h then f:SetHeight(h) end
	if l then f:SetLayer(l) end
	if a then f:SetAlpha(a) end
	return f
end

local function mk_frame(n,c,w,h,l,a,v)
	local f = UI.CreateFrame("Frame", n,c)
	if w then f:SetWidth(w) end
	if h then f:SetHeight(h) end
	if l then f:SetLayer(l) end
	if a then f:SetAlpha(a) end
	if v ~= nil then f:SetVisible(v) end
	return f
end

local function mk_text(n,c,fs,l,t)
	local f = UI.CreateFrame("Text", n,c)
	if fs then f:SetFontSize(fs) end
	if l then f:SetLayer(l) end
	if t then f:SetText(t) end
	return f
end

local function dd_mousein(self, h)
	self:SetBackgroundColor(0,1,0,1)
end

local function dd_mouseout(self, h)
	self:SetBackgroundColor(0,0,0,1)
end

local all_dropdown = {}

local function mk_dropdown(n,c,l,w,t,data,chfunc,e)

	local f = mk_frame(n..".f", c, w, nil,l,nil,nil)
	--f:SetBackgroundColor(0.5,0.5,0.5,0.5)
	
	f.ds = mk_frame(n..".ds", f, w, nil, l+50, nil, false)
	f.ds:SetBackgroundColor(1,0,0,1)
	
	table.insert(all_dropdown, f.ds)
	
	function f.Update(dx)
		for k,v in pairs(dx) do
			if f.dd[k] == nil then
				f.dd[k] = mk_text(n..".dd."..k, f.ds, 12, l+51, nil)
				f.dd[k]:SetWidth(w)
				f.dd[k]:SetBackgroundColor(0,0,0,1)
				if k == 1 then
					f.dd[k]:SetPoint("TOPLEFT", f.ds, "TOPLEFT")
				else
					f.dd[k]:SetPoint("TOPLEFT", f.dd[k-1], "BOTTOMLEFT")
				end
				f.dd[k]:EventAttach(Event.UI.Input.Mouse.Cursor.In, dd_mousein, "Event.UI.Input.Mouse.Cursor.In")				
				f.dd[k]:EventAttach(Event.UI.Input.Mouse.Cursor.Out, dd_mouseout, "Event.UI.Input.Mouse.Cursor.Out")
				f.dd[k]:EventAttach(Event.UI.Input.Mouse.Left.Click, function (self, h)
					f.ti:SetText(dx[k].n)
					f.ds:SetVisible(false)
					if chfunc then chfunc(0,0) end
				end, "Event.UI.Input.Mouse.Left.Click")

			end
			f.dd[k]:SetText(v.n)
		end
		
		for x=1, #f.dd do
			if x <= #dx then
				f.dd[x]:SetVisible(true)
			else
				f.dd[x]:SetVisible(false)
			end
		end

		if #dx > 0 then
			f.ds:SetHeight(#dx * f.dd[1]:GetHeight())
		else
			f.ds:SetHeight(0)
		end
	end
	
	f.lb = mk_text(n..".f.lb", c,14,l+5,t)
	f.lb:SetPoint("TOPLEFT", f, "TOPLEFT")
	f:SetHeight(f.lb:GetHeight())
	
	f.d = mk_texture(n..".d", c, f.lb:GetHeight(),f.lb:GetHeight(),l+5,nil)
	f.d:SetTexture(addon.identifier, "img/dropdown.png")
	f.d:SetPoint("TOPRIGHT", f, "TOPRIGHT")
	
	f.d:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h) 
		local dvis = not f.ds:GetVisible()
		for k,v in pairs(all_dropdown) do
			v:SetVisible(false)
		end
		f.ds:SetVisible(dvis)
	end, "Event.UI.Input.Mouse.Left.Click")
	
	f.ds:SetPoint("TOPRIGHT", f.d, "BOTTOMRIGHT", 0,2)
	
	if e then
		f.ti = UI.CreateFrame("RiftTextfield", n..".ti", c)
		f.ti:SetLayer(l+3)
	else
		f.ti = mk_text(n..".ti", c, nil, l+3, nil)
	end
	f.ti:SetBackgroundColor(0,0,0)
	f.ti:SetPoint("TOPLEFT", f.lb, "TOPRIGHT", 2, 0)
	f.ti:SetHeight(f.lb:GetHeight())
	f.ti:SetWidth(w-((f.lb:GetHeight()/2)+f.lb:GetWidth()+2))
	
	function f:GetText(...) return f.ti:GetText(...) end
	function f:SetText(...) f.ti:SetText(...) end
	
	if chfunc and e then
		f.ti:EventAttach(Event.UI.Textfield.Change, chfunc, "Event.UI.Textfield.Change")	
	end
	
	f.dd = {}
	f.Update(data)

	return f
end

function PI.iset_change(self, h)
	local t = PI.UI.cfg_iset_dd:GetText()
	if PopupItems_Settings.ITEM_SETS[t] ~= nil then
		PI.UI.cfg_iset_dd.ti:SetBackgroundColor(0,0,0)
		
		local ni = #PopupItems_Settings.ITEM_SETS[t].items
		local sk, ek
		
		if ni <= 20 then
			sk = 1
			ek = ni
			PI.UI.cfg_iset_f[1].f.offset = 0
			PI.UI.cfg_sbbg:SetVisible(false)
		else
			if PI.UI.cfg_iset_f[1].f.offset+20 > ni then
				PI.UI.cfg_iset_f[1].f.offset = ni-20
			end
			sk = PI.UI.cfg_iset_f[1].f.offset+1
			ek = PI.UI.cfg_iset_f[1].f.offset+20
			
			local bh = PI.UI.cfg_sbbg:GetHeight()
			local sh = (20/ni)*bh
			local soh = bh-sh
			local so = PI.UI.cfg_iset_f[1].f.offset/(ni-20) * soh
			PI.UI.cfg_sb:SetHeight(sh)
			PI.UI.cfg_sb:SetPoint("TOPLEFT", PI.UI.cfg_sbbg, "TOPLEFT", 0,so)
			PI.UI.cfg_sbbg:SetVisible(true)
		end
		
		for x=sk, ek do
			local k = x-PI.UI.cfg_iset_f[1].f.offset
			local v = PopupItems_Settings.ITEM_SETS[t].items[x]
			PI.UI.cfg_iset_f[k].t:SetText(v.n)
			PI.UI.cfg_iset_f[k].i:SetTexture("Rift", v.i)
			PI.UI.cfg_iset_f[k].f:SetVisible(true)
		end
		
		for x=ek+1, 20 do
			PI.UI.cfg_iset_f[x].f:SetVisible(false)
		end
	else
		PI.UI.cfg_iset_dd.ti:SetBackgroundColor(1,0,0)
		for x=1, 20 do
			PI.UI.cfg_iset_f[x].f:SetVisible(false)
		end
		PI.UI.cfg_iset_f[1].f.offset = 0
	end
end

function PI.cfgslot_update(slot, btyp, dtls, wip)
--print(string.format("PI.cfgslot_update(%s, %s, {%s}, %s)", slot, btyp, Utility.Serialize.Inline(dtls), tostring(wip)))
	if WIP_ACTIVE then
		WIP_CHANGE = wip
		if btyp == PI_ISET then
			CFG_WIPPAGE.slots[slot] = {t=PI_ISET, n=dtls}
			if PopupItems_Settings.ITEM_SETS[dtls] == nil then
				PI.UI.cfg_grid[slot].b:SetTexture(addon.identifier, "img/button_error.png")
				CFG_BTNSTATUS[slot] = "ITEM SET: "..dtls.."\n\nNOTE: Non-existant set.\n\n"
				PI.UI.cfg_grid[slot].t:SetVisible(false)
			elseif #PopupItems_Settings.ITEM_SETS[dtls].items > 0 then
				PI.UI.cfg_grid[slot].b:SetTexture(addon.identifier, "img/button_empty.png")
				PI.UI.cfg_grid[slot].t:SetTexture("Rift", PopupItems_Settings.ITEM_SETS[dtls].items[1].i)
				PI.UI.cfg_grid[slot].t:SetVisible(true)
				CFG_BTNSTATUS[slot] = "ITEM SET: "..dtls.."\n\n\n\n"
			else
				PI.UI.cfg_grid[slot].b:SetTexture(addon.identifier, "img/button_error.png")
				PI.UI.cfg_grid[slot].t:SetVisible(false)
				CFG_BTNSTATUS[slot] = "ITEM SET: "..dtls.."\n\nNOTE: Set has no items in it.\n\n"
			end
		elseif btyp==PI_ITEM then
			CFG_WIPPAGE.slots[slot] = { t=PI_ITEM, id=dtls.id, i=dtls.i, n=dtls.n}
			PI.UI.cfg_grid[slot].b:SetTexture(addon.identifier, "img/button_empty.png")
			PI.UI.cfg_grid[slot].t:SetTexture("Rift", dtls.i)
			CFG_BTNSTATUS[slot] = "ITEM: "..dtls.n.."\n\n\n\n"
			PI.UI.cfg_grid[slot].t:SetVisible(true)			
		elseif btyp==PI_NONE then
			CFG_WIPPAGE.slots[slot] = { t=PI_NONE }
			PI.UI.cfg_grid[slot].b:SetTexture(addon.identifier, "img/button_empty.png")
			PI.UI.cfg_grid[slot].t:SetVisible(false)
			CFG_BTNSTATUS[slot] = "Empty Button\n\n\n\n"		
		elseif btyp==PI_MENU then
			CFG_WIPPAGE.slots[slot] = {t=PI_MENU, n=dtls}
			if PopupItems_Settings.PAGES[dtls] == nil then
				PI.UI.cfg_grid[slot].b:SetTexture(addon.identifier, "img/button_error.png")
				CFG_BTNSTATUS[slot] = "PAGE: "..dtls.."\n\nNOTE: Page does not exist.\n\n"
			else
				if PopupItems_Settings.PAGES[dtls].slots ~= nil and #PopupItems_Settings.PAGES[dtls].slots > 0 then
					PI.UI.cfg_grid[slot].b:SetTexture(addon.identifier, "img/button_menu.png")
					CFG_BTNSTATUS[slot] = "PAGE: "..dtls.."\n\n\n\n"
				elseif PopupItems_Settings.PAGES[dtls].type == PIT_QUEST then
					PI.UI.cfg_grid[slot].b:SetTexture(addon.identifier, "img/button_menu.png")
					CFG_BTNSTATUS[slot] = "PAGE: "..dtls.."\n\n\n\n"
				else
					PI.UI.cfg_grid[slot].b:SetTexture(addon.identifier, "img/button_error.png")
					CFG_BTNSTATUS[slot] = "PAGE: "..dtls.."\n\nNOTE: Page has no content.\n\n"
				end
			end
			PI.UI.cfg_grid[slot].t:SetVisible(false)
		end
		
		if slot == CFG_CURPSEL then
			PI.UI.cfg_pg_status:SetText(CFG_BTNSTATUS[slot])
		end
	else
		print("No active page to place selection onto")
	end
end

function PI.page_change(self,h)
	local t = PI.UI.cfg_page_dd:GetText()
	if PopupItems_Settings.PAGES[t] ~= nil then
		PI.UI.cfg_page_dd.ti:SetBackgroundColor(0,0,0)
		--print("loading page... "..t)
		
		CFG_WIPPAGE = {}
		WIP_CHANGE = false
		WIP_ACTIVE = true
		MergeTable(CFG_WIPPAGE, PopupItems_Settings.PAGES[t])
		
		CFG_BTNSTATUS = {}
		local pg_dtl = PopupItems_Settings.PAGES[t].slots

		if CFG_CURPSEL > 0 then
			PI.UI.cfg_grid[CFG_CURPSEL].b:SetBackgroundColor(0,0,0,0)
			PI.UI.cfg_grid[CFG_CURPSEL].b:SetAlpha(0.6)
			CFG_CURPSEL = 0
		end
		
		for x=2, 9 do
			if pg_dtl[x].t == PI_NONE then
				PI.cfgslot_update(x, PI_NONE, nil, false)
			elseif pg_dtl[x].t == PI_ITEM then
				PI.cfgslot_update(x, PI_ITEM, {id=pg_dtl[x].id, n=pg_dtl[x].n, i=pg_dtl[x].i}, false)
			elseif pg_dtl[x].t == PI_ISET then
				PI.cfgslot_update(x, PI_ISET, pg_dtl[x].n, false)
			elseif pg_dtl[x].t == PI_MENU then
				PI.cfgslot_update(x, PI_MENU, pg_dtl[x].n, false)
			end
		end
	else
		PI.UI.cfg_page_dd.ti:SetBackgroundColor(1,0,0)
	end		
end
	
function PI.BuildUI()
	--print("S>PI.BuildUI()")
	PI.UI.ctx = UI.CreateContext(addon.identifier)
	PI.UI.f = {}
	PI.UI.c = mk_frame("PI_Container", PI.UI.ctx,nil,nil,1,nil,false)

	PI.UI.c:EventAttach(Event.UI.Input.Mouse.Wheel.Forward, function(self, h)
		if PopupItems_Settings.config.ic < 128 then
			PopupItems_Settings.config.ic = PopupItems_Settings.config.ic+1
			PI.Rescale()
		end
	end, "Event.UI.Input.Mouse.Wheel.Forward")

	PI.UI.c:EventAttach(Event.UI.Input.Mouse.Wheel.Back, function(self, h)
		if PopupItems_Settings.config.ic > 8 then
			PopupItems_Settings.config.ic = PopupItems_Settings.config.ic-1
			PI.Rescale()
		end
	end, "Event.UI.Input.Mouse.Wheel.Back")

	for x=1, 9 do
		local b = mk_texture("PI_BButton#"..x, PI.UI.c,64,64,2,0.8)
		local t = mk_texture("PI_TButton#"..x, PI.UI.c,48,48,3,0.6)
		t:SetPoint("CENTER", b, "CENTER")

		b:EventAttach(Event.UI.Input.Mouse.Cursor.In, function(self, h)
			if PI.BUTTONSTATE[x].err == false and PI.BUTTONSTATE[x].btyp ~= PI_NONE then
				cursel = x
				if x == 1 then
					Command.Tooltip(nil)
				elseif PI.BUTTONSTATE[x].btyp == PI_ITEM or PI.BUTTONSTATE[x].btyp == PI_ISET then
					Command.Tooltip(PI.BUTTONSTATE[x].item)
				end
				PI.UI.f[x].b:SetAlpha(1)
				PI.UI.f[x].t:SetAlpha(1)
			end
		end, "Event.UI.Input.Mouse.Cursor.In")

		b:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
			if PI.BUTTONSTATE[x].err == false and PI.BUTTONSTATE[x].btyp ~= PI_NONE then
				if x == cursel then
					cursel = nil
					Command.Tooltip(nil)
				end
				PI.UI.f[x].b:SetAlpha(0.8)
				PI.UI.f[x].t:SetAlpha(0.6)
			end
		end, "Event.UI.Input.Mouse.Cursor.Out")		

		if x==1 then
			b:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
				if #PI.MENUSTACK > 1 then
					local stk_cp = PI.MENUSTACK[#PI.MENUSTACK]
					table.remove(PI.MENUSTACK, #PI.MENUSTACK)
					local stk_pp = PI.MENUSTACK[#PI.MENUSTACK]
					table.remove(PI.MENUSTACK, #PI.MENUSTACK)

					if stk_cp == "QUEST" and stk_pp == "QUEST" then
							PI.SetupPage(stk_pp, qstcrntpage-1)
					else
						qstcrntpage = 0
						PI.SetupPage(stk_pp)
					end
				else
					print("No previous page to go to!")
				end
			end, "Event.UI.Input.Mouse.Left.Click")

			b:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
				PI.UI.cfg:SetVisible(true)
			end, "Event.UI.Input.Mouse.Right.Click")

		else
			b:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
				if PI.BUTTONSTATE[x].err == false then
					if PI.BUTTONSTATE[x].btyp == PI_ITEM or PI.BUTTONSTATE[x].btyp == PI_ISET then
						Command.Item.Standard.Right(_itemdetails[PI.BUTTONSTATE[x].ityp].slot)
					elseif PI.BUTTONSTATE[x].btyp == PI_MENU then
						if PI.BUTTONSTATE[x].item == "QUEST" then
							PI.SetupPage("QUEST", qstcrntpage+1)
						else
							PI.SetupPage(PI.BUTTONSTATE[x].item)
						end
					end
				end
			end, "Event.UI.Input.Mouse.Left.Click")
			b:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
				if PI.BUTTONSTATE[x].err == false then
					if PI.BUTTONSTATE[x].btyp == PI_ITEM or PI.BUTTONSTATE[x].btyp == PI_ISET then
						Command.Item.Standard.Left(_itemdetails[PI.BUTTONSTATE[x].ityp].slot)
					end
				end
			end, "Event.UI.Input.Mouse.Right.Click")
		end

		if x == 1 then
			b:SetPoint("CENTER", PI.UI.c, "CENTER", 0, 0)
		elseif x == 2 then
			b:SetPoint("BOTTOMRIGHT", PI.UI.f[1].b, "TOPLEFT", -2, -2)
		elseif x == 3 then
			b:SetPoint("BOTTOMCENTER", PI.UI.f[1].b, "TOPCENTER", 0, -2)
		elseif x == 4 then
			b:SetPoint("BOTTOMLEFT", PI.UI.f[1].b, "TOPRIGHT", 2, -2)
		elseif x == 5 then
			b:SetPoint("CENTERRIGHT", PI.UI.f[1].b, "CENTERLEFT", -2, 0)
		elseif x == 6 then
			b:SetPoint("CENTERLEFT", PI.UI.f[1].b, "CENTERRIGHT", 2, 0)
		elseif x == 7 then
			b:SetPoint("TOPRIGHT", PI.UI.f[1].b, "BOTTOMLEFT", -2, 2)
		elseif x == 8 then
			b:SetPoint("TOPCENTER", PI.UI.f[1].b, "BOTTOMCENTER", 0, 2)
		elseif x == 9 then
			b:SetPoint("TOPLEFT", PI.UI.f[1].b, "BOTTOMRIGHT", 2, 2)
		end

		local l = mk_text("PI_LButton#"..x, PI.UI.c,12,5,nil)
		l:SetFontColor(1,1,1,1)
		--l:SetBackgroundColor(0.25,0.25,0.25,0.75)
		l:SetEffectGlow({strength=10, blurX=3, blurY=3})
		l:SetPoint("BOTTOMCENTER", t, "BOTTOMCENTER")

		local s = mk_text("PI_SButton#"..x, PI.UI.c,12,5,nil)
		s:SetFontColor(1,1,1,1)
		--s:SetBackgroundColor(0.25,0.25,0.25,0.75)
		s:SetEffectGlow({strength=10, blurX=3, blurY=3})
		s:SetPoint("TOPLEFT", t, "TOPLEFT",0,0)

		PI.UI.f[x] = {t=t, l=l, s=s, b=b}
	end

	PI.UI.cfg = UI.CreateFrame("RiftWindow", "PI.UI.cfg", PI.UI.ctx)
	PI.UI.cfg:SetVisible(false)
	PI.UI.cfg:SetTitle("POPUPITEMS Configuration")
	PI.UI.cfg:SetLayer(1)

	local cfgtrim = {}
	cfgtrim.l, cfgtrim.t, cfgtrim.r, cfgtrim.b = PI.UI.cfg:GetTrimDimensions()

	PI.UI.cfg_p1 = mk_frame("PI.UI.cfg_p1", PI.UI.cfg,255,500,2,nil,nil)
	--PI.UI.cfg_p1:SetBackgroundColor(0.5,0,0,0.5)
	PI.UI.cfg_p1:SetPoint("TOPLEFT", PI.UI.cfg, "TOPLEFT", cfgtrim.l, cfgtrim.t)
	
	PI.UI.cfg_p2 = mk_frame("PI.UI.cfg_p2", PI.UI.cfg,250,500,2,nil,nil)
	--PI.UI.cfg_p2:SetBackgroundColor(0,0.5,0,0.5)
	PI.UI.cfg_p2:SetPoint("TOPLEFT", PI.UI.cfg_p1, "TOPRIGHT", 2,0)

	PI.UI.cfg_p3 = mk_frame("PI.UI.cfg_p3", PI.UI.cfg,250,500,2,nil,nil)
	--PI.UI.cfg_p3:SetBackgroundColor(0,0,0.5,0.5)
	PI.UI.cfg_p3:SetPoint("TOPLEFT", PI.UI.cfg_p2, "TOPRIGHT", 2,0)

	PI.UI.vsplit1 = mk_frame("PI.UI.vsplit1", PI.UI.cfg, nil, nil, 5, nil, true)
	PI.UI.vsplit2 = mk_frame("PI.UI.vsplit2", PI.UI.cfg, nil, nil, 5, nil, true)
	
	PI.UI.vsplit1:SetPoint("TOPLEFT", PI.UI.cfg_p1, "TOPRIGHT", 0, 20)
	PI.UI.vsplit1:SetPoint("BOTTOMRIGHT", PI.UI.cfg_p2, "BOTTOMLEFT", 0, -20)
	PI.UI.vsplit1:SetBackgroundColor(0.5,0.5,0.5,0.5)

	PI.UI.vsplit2:SetPoint("TOPLEFT", PI.UI.cfg_p2, "TOPRIGHT", 0, 20)
	PI.UI.vsplit2:SetPoint("BOTTOMRIGHT", PI.UI.cfg_p3, "BOTTOMLEFT", 0, -20)
	PI.UI.vsplit2:SetBackgroundColor(0.5,0.5,0.5,0.5)
	
	PI.UI.cfg:SetWidth(763+cfgtrim.l+cfgtrim.r)
	PI.UI.cfg:SetHeight(500+cfgtrim.t+cfgtrim.b)
	
	PI.UI.cfg:GetBorder():EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
		self.MouseDown = true
		local mouseData = Inspect.Mouse()
		self.sx = mouseData.x - PI.UI.cfg:GetLeft()
		self.sy = mouseData.y - PI.UI.cfg:GetTop()
	end, "Event.UI.Input.Mouse.Left.Down")	

	PI.UI.cfg:GetBorder():EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
		if self.MouseDown then
			local nx, ny
			local mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			PI.UI.cfg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
		end
	end, "Event.UI.Input.Mouse.Cursor.Move")

	PI.UI.cfg:GetBorder():EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
		self.MouseDown = false
		PopupItems_Settings.config.cfgx= PI.UI.cfg:GetLeft()
		PopupItems_Settings.config.cfgy= PI.UI.cfg:GetTop()
	end, "Event.UI.Input.Mouse.Left.Up")
	
	PI.UI.cfg_h1 = mk_text("PI.UI.cfg_h1", PI.UI.cfg,16,3,"ITEM SETS SETUP")
	PI.UI.cfg_h1:SetPoint("TOPCENTER", PI.UI.cfg_p1, "TOPCENTER")

	PI.UI.cfg_h2 = mk_text("PI.UI.cfg_h2", PI.UI.cfg,16,3,"ITEMS")
	PI.UI.cfg_h2:SetPoint("TOPCENTER", PI.UI.cfg_p2, "TOPCENTER")
	
	PI.UI.cfg_h3 = mk_text("PI.UI.cfg_h3", PI.UI.cfg,16,3,"PAGE SETUP")
	PI.UI.cfg_h3:SetPoint("TOPCENTER", PI.UI.cfg_p3, "TOPCENTER")
	
	PI.UI.cfg_iset_dd = mk_dropdown("PI.UI.cfg_iset_dd", PI.UI.cfg, 50, 246, "Current:", {}, PI.iset_change, true)
	PI.UI.cfg_iset_dd:SetPoint("TOPLEFT", PI.UI.cfg_p1, "TOPLEFT", 2, PI.UI.cfg_h1:GetBottom()+2-PI.UI.cfg_p1:GetTop())
	
	PI.UI.cfg_iset_f = {}
	
	local ht = 0
	local mouseClick = 0
	local clickMode = ""

	local function is_mousein(self, h)
		PI.UI.cfg_iset_f[self.slotID].t:SetBackgroundColor(0,1,0)
	end

	local function is_mouseout(self, h)
		PI.UI.cfg_iset_f[self.slotID].t:SetBackgroundColor(0,0,0)
	end
	
	local function is_wheelback(self, h)
		PI.UI.cfg_iset_f[1].f.offset = PI.UI.cfg_iset_f[1].f.offset+1
		PI.iset_change(0,0)
	end
	
	local function is_wheelforward(self, h)
		if PI.UI.cfg_iset_f[1].f.offset > 0 then
			PI.UI.cfg_iset_f[1].f.offset = PI.UI.cfg_iset_f[1].f.offset-1
			PI.iset_change(0,0)
		end
	end
	
	local function is_leftclick_down(self, h)
		local t = PI.UI.cfg_iset_dd:GetText()
		if self.slotID < #PopupItems_Settings.ITEM_SETS[t].items then
			local new_items = {}
			local t = PI.UI.cfg_iset_dd:GetText()
			PI.UI.cfg_iset_f[self.slotID].f:SetBackgroundColor(0,0,0)
			for k,v in ipairs(PopupItems_Settings.ITEM_SETS[t].items) do
				table.insert(new_items, {d=v, sk=k})
			end
			new_items[self.slotID].sk = self.slotID+1.5
			table.sort(new_items, function(a,b) return a.sk < b.sk end)
			PopupItems_Settings.ITEM_SETS[t].items = {}
			for k,v in ipairs(new_items) do
				table.insert(PopupItems_Settings.ITEM_SETS[t].items, v.d)
			end
			PI.iset_change(0,0)
		end
	end
	
	local function is_leftclick_up(self, h)
		if self.slotID > 1 then
			local new_items = {}
			local t = PI.UI.cfg_iset_dd:GetText()
			PI.UI.cfg_iset_f[self.slotID].f:SetBackgroundColor(0,0,0)
			for k,v in ipairs(PopupItems_Settings.ITEM_SETS[t].items) do
				table.insert(new_items, {d=v, sk=k})
			end
			new_items[self.slotID].sk = self.slotID-1.5
			table.sort(new_items, function(a,b) return a.sk < b.sk end)
			PopupItems_Settings.ITEM_SETS[t].items = {}
			for k,v in ipairs(new_items) do
				table.insert(PopupItems_Settings.ITEM_SETS[t].items, v.d)
			end
			PI.iset_change(0,0)
		end
	end
	
	local function is_rightclick(self, h)
		local t = PI.UI.cfg_iset_dd:GetText()
		PI.UI.cfg_iset_f[self.slotID].f:SetBackgroundColor(0,0,0)
		table.remove(PopupItems_Settings.ITEM_SETS[t].items, self.slotID)
		PI.iset_change(0,0)
	end
	
	PI.UI.cfg_isd_ctr = mk_frame("PI.UI.cfg_isd_ctr", PI.UI.cfg, 246, nil, 18, 1, true)
	PI.UI.cfg_isd_ctr:SetPoint("TOPLEFT", PI.UI.cfg_iset_dd, "BOTTOMLEFT", 0, 2)
	
	PI.UI.cfg_sbbg = mk_frame("PI.UI.cfg_isd_sbbg", PI.UI.cfg, 4, nil, 18, 1, false)
	PI.UI.cfg_sb = mk_frame("PI.UI.cfg_isd_sb", PI.UI.cfg_sbbg, 4, nil, 20, 1, true)
	
	PI.UI.cfg_sbbg:SetPoint("TOPLEFT", PI.UI.cfg_isd_ctr, "TOPLEFT", 0, 0)
	PI.UI.cfg_sbbg:SetBackgroundColor(0,0,0)
	PI.UI.cfg_sb:SetPoint("TOPLEFT", PI.UI.cfg_sbbg, "TOPLEFT", 0, 0)
	PI.UI.cfg_sb:SetBackgroundColor(0,0,1)
	
	for x=1, 20 do
		local f = mk_frame("PI.UI.cfg_iset_f.f"..x, PI.UI.cfg_isd_ctr, 246, nil, 19,1,false)
		local i = mk_texture("PI.UI.cfg_iset_f.i"..x, f,nil,nil,20,nil)
		local u = mk_texture("PI.UI.cfg_iset_f.u"..x, f,nil,nil,20,nil)
		local d = mk_texture("PI.UI.cfg_iset_f.d"..x, f,nil,nil,20,nil)
		local r = mk_texture("PI.UI.cfg_iset_f.x"..x, f,nil,nil,20,nil)
		local t = mk_text("PI.UI.cfg_iset_f.t"..x, f, 12, 20, nil)
		i:SetPoint("TOPLEFT", f, "TOPLEFT", 0,0)
		t:SetPoint("TOPLEFT", i, "TOPRIGHT", 0,0)
		u:SetPoint("TOPLEFT", t, "TOPRIGHT", 0,0)
		d:SetPoint("TOPLEFT", u, "TOPRIGHT", 0,0)
		r:SetPoint("TOPLEFT", d, "TOPRIGHT", 0,0)
		f:SetBackgroundColor(0,0,0)
		if x == 1 then
			f:SetPoint("TOPLEFT", PI.UI.cfg_sbbg, "TOPRIGHT", 1, 0)
			t:SetText("QQqq")
			ht = t:GetHeight()
			t:SetText("")
			PI.UI.cfg_sbbg:SetHeight(ht * 20)
		else
			f:SetPoint("TOPLEFT", PI.UI.cfg_iset_f[x-1].f, "BOTTOMLEFT", 0, 0)
		end
		
		i:SetHeight(ht)
		i:SetWidth(ht)
		
		u:SetHeight(ht)
		u:SetWidth(ht)
		
		d:SetHeight(ht)
		d:SetWidth(ht)

		r:SetHeight(ht)
		r:SetWidth(ht)
		
		r:SetTexture(addon.identifier, "img/itemdel.png")
		u:SetTexture(addon.identifier, "img/itemup.png")
		d:SetTexture(addon.identifier, "img/itemdown.png")
		
		t:SetHeight(ht)
		t:SetWidth(246-(4*ht))
		
		f:SetHeight(ht)
		t.slotID = x
		u.slotID = x
		d.slotID = x
		r.slotID = x
		
		t:EventAttach(Event.UI.Input.Mouse.Cursor.In, is_mousein, "Event.UI.Input.Mouse.Cursor.In")
		t:EventAttach(Event.UI.Input.Mouse.Cursor.Out, is_mouseout, "Event.UI.Input.Mouse.Cursor.Out")
		u:EventAttach(Event.UI.Input.Mouse.Left.Click, is_leftclick_up, "Event.UI.Input.Mouse.Left.Click")
		d:EventAttach(Event.UI.Input.Mouse.Left.Click, is_leftclick_down, "Event.UI.Input.Mouse.Left.Click")
		r:EventAttach(Event.UI.Input.Mouse.Right.Click, is_rightclick, "Event.UI.Input.Mouse.Left.Click")
		f:EventAttach(Event.UI.Input.Mouse.Wheel.Forward, is_wheelforward, "Event.UI.Input.Mouse.Wheel.Forward")
		f:EventAttach(Event.UI.Input.Mouse.Wheel.Back, is_wheelback, "Event.UI.Input.Mouse.Wheel.Back")
		--f:EventAttach(Event.UI.Input.Mouse.Right.Click, is_rightclick , "Event.UI.Input.Mouse.Right.Click")
		--f:EventAttach(Event.UI.Input.Mouse.Left.Click, is_leftclick, "Event.UI.Input.Mouse.Left.Click")
		
		PI.UI.cfg_iset_f[x] = {t=t, i=i, f=f, u=u, d=d, r=r}
	end
	PI.UI.cfg_iset_f[1].f.offset = 0
	
	PI.UI.cfg_iset_new = UI.CreateFrame("RiftButton", "PI.UI.cfg_iset_new", PI.UI.cfg)
	PI.UI.cfg_iset_new:SetSkin("default")
	PI.UI.cfg_iset_new:SetText("NEW")
	PI.UI.cfg_iset_new:SetWidth(113)
	PI.UI.cfg_iset_new:SetLayer(15)
	PI.UI.cfg_iset_new:SetPoint("TOPLEFT", PI.UI.cfg_iset_f[20].f, "BOTTOMLEFT", 2, 4)
	PI.UI.cfg_iset_new:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		local t = PI.UI.cfg_iset_dd.ti:GetText()
		if PopupItems_Settings.ITEM_SETS[t] == nil then		
			PopupItems_Settings.ITEM_SETS[t] = {
				delete=true, items = {}
			}
			table.insert(DD_ISET, {n=t, i=nil, sk=nil})
			table.sort(DD_ISET, function(a,b) return a.n < b.n end)
			PI.UI.cfg_iset_dd.Update(DD_ISET)
			PI.UI.cfg_iset_sel_dd.Update(DD_ISET)
			PI.iset_change(0,0)
			print("CFG_WIPPAGE:")
			dump(CFG_WIPPAGE)
			if CFG_WIPPAGE.slots then
				for k,v in pairs(CFG_WIPPAGE.slots) do
					if v.t == PI_ISET and v.n == t then
						PI.cfgslot_update(k, PI_ISET, t, true)
					end
				end			
			end
		else
			print("page exists")
		end
	end, "Event.UI.Input.Mouse.Left.Click")
	
	PI.UI.cfg_iset_del = UI.CreateFrame("RiftButton", "PI.UI.cfg_iset_del", PI.UI.cfg)
	PI.UI.cfg_iset_del:SetSkin("default")
	PI.UI.cfg_iset_del:SetText("DELETE")
	PI.UI.cfg_iset_del:SetWidth(113)
	PI.UI.cfg_iset_del:SetLayer(15)
	PI.UI.cfg_iset_del:SetPoint("TOPRIGHT", PI.UI.cfg_iset_f[20].f, "BOTTOMRIGHT", -2, 4)
	PI.UI.cfg_iset_del:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		local t = PI.UI.cfg_iset_dd.ti:GetText()
		if PopupItems_Settings.ITEM_SETS[t] ~= nil then
			if PopupItems_Settings.ITEM_SETS[t].delete ~= false then
				PopupItems_Settings.ITEM_SETS[t] = nil
				DD_ISET = {}
				for k,v in pairs(PopupItems_Settings.ITEM_SETS) do
					table.insert(DD_ISET, {n=k, i=nil, sk=nil})
				end
				table.sort(DD_ISET, function(a,b) return a.n < b.n end)
				PI.UI.cfg_iset_dd:SetText("Select Itemset...")
				PI.UI.cfg_iset_dd.Update(DD_ISET)
				PI.UI.cfg_iset_sel_dd.Update(DD_ISET)
				for x=1, 20 do
					PI.UI.cfg_iset_f[x].f:SetVisible(false)
				end
				for k,v in pairs(CFG_WIPPAGE.slots) do
					if v.t == PI_ISET and v.n == t then
						PI.cfgslot_update(k, PI_ISET, t, true)
					end
				end
			else
				print("Item set is protected.")
			end
		else
			print("No such item set to delete")
		end
	end, "Event.UI.Input.Mouse.Left.Click")	

	PI.UI.cfg_drop = mk_texture("PI.UI.cfg_drop", PI.UI.cfg, 96,96,10,nil)
	PI.UI.cfg_drop:SetTexture(addon.identifier, "img/button_green.png")
	PI.UI.cfg_drop:SetPoint("TOPCENTER", PI.UI.cfg_h2, "BOTTOMCENTER", 0,2)
	
	PI.UI.cfg_drop_itm = mk_texture("PI.UI.cfg_drop_itm", PI.UI.cfg, 72,72, 15,nil)
	PI.UI.cfg_drop_itm:SetPoint("CENTER", PI.UI.cfg_drop, "CENTER")

	PI.UI.cfg_drop:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
		local ty,hl = Inspect.Cursor()
		if ty == "item" then
			local id = Inspect.Item.Detail(hl)
			local ic = string.gsub(id.icon, ".*item_icons", "item_icons")
			ic = string.gsub(ic, ".*ability_icons", "ability_icons")
			ic = string.gsub(ic, "\\", "\\\\")
			CFG_CURITEM = {id=id.type, n=id.name, z=LIBZONECHANGE.currentZoneID, i=ic, dx=id}
			PI.UI.cfg_t2:SetText("NAME: "..id.name)
			PI.UI.cfg_drop_itm:SetTexture("Rift", id.icon)
			--print(string.format("{id = \"%s\", n = \"%s\", z = \"%s\", i=\"%s\"},",id.type, id.name, LIBZONECHANGE.currentZoneID, ic))
		end
		Command.Cursor(nil)
	end, "Event.UI.Input.Mouse.Left.Up")
	
	PI.UI.cfg_t1 = mk_text("PI.UI.cfg_t1", PI.UI.cfg,12,3,"Drag an item onto the green square")
	PI.UI.cfg_t1:SetPoint("TOPCENTER", PI.UI.cfg_drop, "BOTTOMCENTER", 0,2)

	PI.UI.cfg_t2 = mk_text("PI.UI.cfg_t2", PI.UI.cfg,14,3,"NAME:")
	PI.UI.cfg_t2:SetPoint("TOPLEFT", PI.UI.cfg_p2, "TOPLEFT", 2, PI.UI.cfg_t1:GetBottom()+2-PI.UI.cfg_p2:GetTop())
	PI.UI.cfg_t2:SetWidth(246)
	
	PI.UI.cfg_item_set = UI.CreateFrame("RiftButton", "PI.UI.cfg_item_set", PI.UI.cfg)
	PI.UI.cfg_item_set:SetSkin("default")
	PI.UI.cfg_item_set:SetText("Add to SET")
	PI.UI.cfg_item_set:SetWidth(113)
	PI.UI.cfg_item_set:SetLayer(15)
	PI.UI.cfg_item_set:SetPoint("TOPLEFT", PI.UI.cfg_t2, "BOTTOMLEFT", 2,4)
	
	PI.UI.cfg_item_set:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		if CFG_CURITEM.id == nil then
			print("No selected item.")
		else
			local t = PI.UI.cfg_iset_dd:GetText()
			if t == "Select Itemset..." then
				print("No set selected")
			else
				if PopupItems_Settings.ITEM_SETS[t] == nil then
					print("No such item set: "..t)
				else
					if PopupItems_Settings.ITEM_SETS[t].items == nil then
						PopupItems_Settings.ITEM_SETS[t].items = {}
					end
					local a = true
					for k,v in ipairs(PopupItems_Settings.ITEM_SETS[t].items) do
						if v.id == CFG_CURITEM.id then
							a = false
							print("Item is already in that itemset!")
							break
						end
					end
					if a == true then
						_registereditems[CFG_CURITEM.id] = true
						Library.LibInventory.RegisterItem(CFG_CURITEM.id, PI.cb_libinvITEM)
						if t == "QUEST_ITEMS" then
							table.insert(PopupItems_Settings.ITEM_SETS[t].items, {id=CFG_CURITEM.id, n=CFG_CURITEM.n, i=CFG_CURITEM.i, z=CFG_CURITEM.z})
							PI.Event_libZoneChange_Player(0, "", LIBZONECHANGE.currentZoneID)
						else
							--if #PopupItems_Settings.ITEM_SETS[t].items < 20 then
								table.insert(PopupItems_Settings.ITEM_SETS[t].items, {id=CFG_CURITEM.id, n=CFG_CURITEM.n, i=CFG_CURITEM.i})
							--else
--								print("ItemSet already has 20 items in it. Please remove some to add more.")
							--end
						end
						if #PopupItems_Settings.ITEM_SETS[t].items == 1 and CFG_WIPPAGE.slots then
							for k,v in pairs(CFG_WIPPAGE.slots) do
								if v.t == PI_ISET and v.n == t then
									PI.cfgslot_update(k, PI_ISET, t, true)
								end
							end
						end
						PI.iset_change(0,0)
					end
				end
			end
		end
	end, "Event.UI.Input.Mouse.Left.Click")

	PI.UI.cfg_item_page = UI.CreateFrame("RiftButton", "PI.UI.cfg_item_page", PI.UI.cfg)
	PI.UI.cfg_item_page:SetSkin("default")
	PI.UI.cfg_item_page:SetText("Add to PAGE")
	PI.UI.cfg_item_page:SetWidth(113)
	PI.UI.cfg_item_page:SetLayer(15)
	PI.UI.cfg_item_page:SetPoint("TOPRIGHT", PI.UI.cfg_t2, "BOTTOMRIGHT", -2,4)
	
	PI.UI.cfg_item_page:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		if CFG_CURITEM.id == nil then
			print("No item selected")
		else
			if CFG_CURPSEL > 0 then
				if CFG_WIPPAGE.slots[CFG_CURPSEL].t == PI_NONE then
					PI.cfgslot_update(CFG_CURPSEL, PI_ITEM, {id=CFG_CURITEM.id, i=CFG_CURITEM.i, n=CFG_CURITEM.n}, true)
					_registereditems[CFG_CURITEM.id] = true
					Library.LibInventory.RegisterItem(CFG_CURITEM.id, PI.cb_libinvITEM)
				else
					print("Slot is not empty")
				end
			else
				print("No slot selected on current page to place this item")
			end		
		end
	end, "Event.UI.Input.Mouse.Left.Click")
	
	PI.UI.cfg_h2b = mk_text("PI.UI.cfg_h2b", PI.UI.cfg,16,3,"ITEM SETS")
	PI.UI.cfg_h2b:SetPoint("TOPCENTER", PI.UI.cfg_p2, "TOPCENTER", 0, PI.UI.cfg_item_page:GetBottom()+24-PI.UI.cfg_p2:GetTop() )

	PI.UI.cfg_iset_sel_dd = mk_dropdown("PI.UI.cfg_iset_sel_dd", PI.UI.cfg, 100, 246, "Set:", {}, nil, false)
	PI.UI.cfg_iset_sel_dd:SetPoint("TOPCENTER", PI.UI.cfg_h2b, "BOTTOMCENTER", 0, 4)
	
	PI.UI.cfg_iset_page = UI.CreateFrame("RiftButton", "PI.UI.cfg_iset_page", PI.UI.cfg)
	PI.UI.cfg_iset_page:SetSkin("default")
	PI.UI.cfg_iset_page:SetText("Add to PAGE")
	PI.UI.cfg_iset_page:SetWidth(113)
	PI.UI.cfg_iset_page:SetLayer(15)
	PI.UI.cfg_iset_page:SetPoint("TOPCENTER", PI.UI.cfg_iset_sel_dd, "BOTTOMCENTER", 0,4)
	PI.UI.cfg_iset_page:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		local t = PI.UI.cfg_iset_sel_dd:GetText()
		if t == "Select Page..." then
			print("No page selected")
		else
			if PI.UI.cfg_page_dd:GetText() == "Select Page..." then
				print("No active page to add items to")
			else
				if CFG_CURPSEL > 0 then
					if CFG_WIPPAGE.slots[CFG_CURPSEL].t == PI_NONE then
						PI.cfgslot_update(CFG_CURPSEL, PI_ISET, t, true)
					else
						print("Slot is not empty")
					end
				else
					print("No slot selected on current page to place this item")
				end
			end
		end
	end, "Event.UI.Input.Mouse.Left.Click")
	
	PI.UI.cfg_h2c = mk_text("PI.UI.cfg_h2c", PI.UI.cfg,16,3,"PAGES")
	PI.UI.cfg_h2c:SetPoint("TOPCENTER", PI.UI.cfg_iset_page, "BOTTOMCENTER", 0, 24)

	PI.UI.cfg_page_sel_dd = mk_dropdown("PI.UI.cfg_page_sel_dd", PI.UI.cfg, 50, 246, "Page:", {}, nil, false)
	PI.UI.cfg_page_sel_dd:SetPoint("TOPCENTER", PI.UI.cfg_h2c, "BOTTOMCENTER", 0, 4)

	PI.UI.cfg_page_page = UI.CreateFrame("RiftButton", "PI.UI.cfg_page_page", PI.UI.cfg)
	PI.UI.cfg_page_page:SetSkin("default")
	PI.UI.cfg_page_page:SetText("Add to PAGE")
	PI.UI.cfg_page_page:SetWidth(113)
	PI.UI.cfg_page_page:SetLayer(15)
	PI.UI.cfg_page_page:SetPoint("TOPCENTER", PI.UI.cfg_page_sel_dd, "BOTTOMCENTER", 0,4)
	PI.UI.cfg_page_page:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		local t = PI.UI.cfg_page_sel_dd:GetText()
		if t == "Select Page..." then
			print("No page selected")
		else
			if PI.UI.cfg_page_dd:GetText() == "Select Page..." then
				print("No active page to add items to")
			else
				if CFG_CURPSEL > 0 then
					if CFG_WIPPAGE.slots[CFG_CURPSEL].t == PI_NONE then
						PI.cfgslot_update(CFG_CURPSEL, PI_MENU, t, true)
					else
						print("Slot is not empty")
					end
				else
					print("No slot selected on current page to place this item")
				end				
			end
		end
	end, "Event.UI.Input.Mouse.Left.Click")	
			
	PI.UI.cfg_page_dd = mk_dropdown("PI.UI.cfg_page_dd", PI.UI.cfg, 50, 246, "Current:", {}, PI.page_change, true)
	PI.UI.cfg_page_dd:SetPoint("TOPLEFT", PI.UI.cfg_p3, "TOPLEFT", 2, PI.UI.cfg_h3:GetBottom()+2-PI.UI.cfg_p3:GetTop())
	
	PI.UI.cfg_grid = {}
	
	for x=2,9 do
		local b = mk_texture("PI_cfg_BButton#"..x, PI.UI.cfg,64,64,10,0.6)
		b:SetTexture(addon.identifier, "img/button_empty.png")
	
		local t = mk_texture("PI_cfg_TButton#"..x, PI.UI.cfg,48,48,15,0.6)
		t:SetPoint("CENTER", b, "CENTER")
		
		b:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
			if WIP_ACTIVE then
				if CFG_CURPSEL > 0 then
					PI.UI.cfg_grid[CFG_CURPSEL].b:SetBackgroundColor(0,0,0,0)
					PI.UI.cfg_grid[CFG_CURPSEL].b:SetAlpha(0.6)
				end
				CFG_CURPSEL = x
				PI.UI.cfg_grid[CFG_CURPSEL].b:SetBackgroundColor(0,1,0,1)
				PI.UI.cfg_grid[CFG_CURPSEL].b:SetAlpha(1)
				if CFG_BTNSTATUS[x] ~= nil then
					PI.UI.cfg_pg_status:SetText(CFG_BTNSTATUS[x])
				end
			end
		end, "Event.UI.Input.Mouse.Left.Click")

		b:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
			if WIP_ACTIVE then
				if CFG_CURPSEL > 0 and CFG_WIPPAGE.slots[CFG_CURPSEL].t ~= PI_NONE then
					if CFG_CURPSEL == x then
						CFG_WIPPAGE.slots[CFG_CURPSEL] = { t=PI_NONE }
						PI.UI.cfg_grid[CFG_CURPSEL].b:SetTexture(addon.identifier, "img/button_empty.png")
						PI.UI.cfg_grid[CFG_CURPSEL].t:SetVisible(false)
						CFG_BTNSTATUS[CFG_CURPSEL] = "Empty Button\n\n\n\n"
						PI.UI.cfg_pg_status:SetText(CFG_BTNSTATUS[CFG_CURPSEL])
						WIP_CHANGE = true
					else
						print("Can only clear the current selection.".."(x="..x..",cur="..CFG_CURPSEL..")")
					end
				--else
				--	print(string.format("CFG_CURPSEL = %d (>0), CFG_WIPPAGE.slots[CFG_CURPSEL].t = %d (~= %d)", CFG_CURPSEL,CFG_WIPPAGE.slots[CFG_CURPSEL].t, PI_NONE))
				end
			--else
			--	print("WIP_ACTIVE = false")
			end
		end, "Event.UI.Input.Mouse.Right.Click")
		
		PI.UI.cfg_grid[x] = {b=b, t=t}
	end
	
	PI.UI.cfg_grid[3].b:SetPoint("TOPCENTER", PI.UI.cfg_page_dd, "BOTTOMCENTER", 0, 2)
	PI.UI.cfg_grid[4].b:SetPoint("TOPLEFT", PI.UI.cfg_grid[3].b, "TOPRIGHT", 2, 0)
	PI.UI.cfg_grid[2].b:SetPoint("TOPRIGHT", PI.UI.cfg_grid[3].b, "TOPLEFT", -2, 0)
	PI.UI.cfg_grid[6].b:SetPoint("TOPLEFT", PI.UI.cfg_grid[4].b, "BOTTOMLEFT", 0, 2)
	PI.UI.cfg_grid[5].b:SetPoint("TOPLEFT", PI.UI.cfg_grid[2].b, "BOTTOMLEFT", 0, 2)
	PI.UI.cfg_grid[7].b:SetPoint("TOPLEFT", PI.UI.cfg_grid[5].b, "BOTTOMLEFT", 0, 2)
	PI.UI.cfg_grid[8].b:SetPoint("TOPLEFT", PI.UI.cfg_grid[7].b, "TOPRIGHT", 2, 0)
	PI.UI.cfg_grid[9].b:SetPoint("TOPLEFT", PI.UI.cfg_grid[8].b, "TOPRIGHT", 2, 0)

	PI.UI.cfg_pg_status = mk_text("PI.UI.cfg_pg_status", PI.UI.cfg,12,15,"\n\n\n\n")
	PI.UI.cfg_pg_status:SetBackgroundColor(0,0,0)
	PI.UI.cfg_pg_status:SetWidth(246)
	PI.UI.cfg_pg_status:SetPoint("TOPLEFT", PI.UI.cfg_p3, "TOPLEFT", 2, PI.UI.cfg_grid[9].b:GetBottom()+4-PI.UI.cfg_p3:GetTop())
	
	PI.UI.cfg_page_new = UI.CreateFrame("RiftButton", "PI.UI.cfg_page_new", PI.UI.cfg)
	PI.UI.cfg_page_new:SetSkin("default")
	PI.UI.cfg_page_new:SetText("NEW")
	PI.UI.cfg_page_new:SetWidth(113)
	PI.UI.cfg_page_new:SetLayer(15)
	PI.UI.cfg_page_new:SetPoint("TOPLEFT", PI.UI.cfg_pg_status, "BOTTOMLEFT", 2, 4)
	PI.UI.cfg_page_new:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		local t = PI.UI.cfg_page_dd:GetText()
		if t ~= "Select Page..." then
			if PopupItems_Settings.PAGES[t] == nil then
				PopupItems_Settings.PAGES[t] = {
					delete=true, type = PIT_NORMAL,
					slots = {
						nil, {t=PI_NONE},{t=PI_NONE},
						{t=PI_NONE},{t=PI_NONE},{t=PI_NONE},
						{t=PI_NONE},{t=PI_NONE},{t=PI_NONE}
					}
				}
				table.insert(DD_PAGE, {n=t, i=nil, sk=nil})
				table.insert(DD_PAGESEL, {n=t, i=nil, sk=nil})
				table.sort(DD_PAGE, function(a,b) return a.n < b.n end)
				table.sort(DD_PAGESEL, function(a,b) return a.n < b.n end)
				PI.UI.cfg_page_dd.Update(DD_PAGE)
				PI.UI.cfg_page_sel_dd.Update(DD_PAGESEL)
				PI.page_change(0,0)
			else
				print("page exists")
			end
		else
			print("No new page selected")
		end
	end, "Event.UI.Input.Mouse.Left.Click")
	
	PI.UI.cfg_page_del = UI.CreateFrame("RiftButton", "PI.UI.cfg_page_del", PI.UI.cfg)
	PI.UI.cfg_page_del:SetSkin("default")
	PI.UI.cfg_page_del:SetText("DELETE")
	PI.UI.cfg_page_del:SetWidth(113)
	PI.UI.cfg_page_del:SetLayer(15)
	PI.UI.cfg_page_del:SetPoint("TOPRIGHT", PI.UI.cfg_pg_status, "BOTTOMRIGHT", -2, 4)
	PI.UI.cfg_page_del:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		local t = PI.UI.cfg_page_dd:GetText()
		if t ~= "Select Page..." then
			if PopupItems_Settings.PAGES[t] ~= nil then
				if PopupItems_Settings.PAGES[t].delete ~= false then
					PopupItems_Settings.PAGES[t] = nil
					DD_PAGE = {}
					DD_PAGESEL={}
					for k,v in pairs(PopupItems_Settings.PAGES) do
						if k ~= "QUEST" then
							table.insert(DD_PAGE, {n=k, i=nil, sk=nil})
						end
						table.insert(DD_PAGESEL, {n=k, i=nil, sk=nil})
					end
					table.sort(DD_PAGE, function(a,b) return a.n < b.n end)
					table.sort(DD_PAGESEL, function(a,b) return a.n < b.n end)
					PI.UI.cfg_page_dd:SetText("Select Page...")
					PI.UI.cfg_page_sel_dd:SetText("Select Page...")
					PI.UI.cfg_page_dd.Update(DD_PAGE)
					PI.UI.cfg_page_sel_dd.Update(DD_PAGESEL)
					for x=2, 9 do
						PI.UI.cfg_grid[x].b:SetTexture(addon.identifier, "img/button_empty.png")
						PI.UI.cfg_grid[x].t:SetVisible(false)
					end
					if CFG_CURPSEL > 0 then
						PI.UI.cfg_grid[CFG_CURPSEL].b:SetBackgroundColor(0,0,0,0)
						PI.UI.cfg_grid[CFG_CURPSEL].b:SetAlpha(0.6)
						CFG_CURPSEL=0
					end
					CFG_BTNSTATUS = {}
					WIP_ACTIVE = false
					print("delete page")
				else
					print("Page is protected.")
				end
			else
				print("page does not exist")
			end
		else
			print("No page selected to delete")
		end
	end, "Event.UI.Input.Mouse.Left.Click")

	PI.UI.cfg_APPLY = UI.CreateFrame("RiftButton", "PI.UI.cfg_APPLY", PI.UI.cfg)
	PI.UI.cfg_APPLY:SetSkin("default")
	PI.UI.cfg_APPLY:SetText("APPLY")
	PI.UI.cfg_APPLY:SetWidth(150)
	PI.UI.cfg_APPLY:SetLayer(20)
	PI.UI.cfg_APPLY:SetPoint("BOTTOMCENTER", PI.UI.cfg_p3, "BOTTOMCENTER", 0, -4)
	PI.UI.cfg_APPLY:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		if WIP_CHANGE then
			local t = PI.UI.cfg_page_dd:GetText()
			--print("Applying changes to page: "..t)
			PopupItems_Settings.PAGES[t] = {}
			MergeTable(PopupItems_Settings.PAGES[t], CFG_WIPPAGE)
			PI.page_change(0,0)
			PI.LoadPage(CURRENT_PAGE)
			WIP_CHANGE = false
		end
	end, "Event.UI.Input.Mouse.Left.Click")

	PI.UI.cfg_close = UI.CreateFrame("RiftButton", "PI.UI.cfg_close", PI.UI.cfg)
	PI.UI.cfg_close:SetSkin("close")
	PI.UI.cfg_close:SetLayer(2)
	PI.UI.cfg_close:SetPoint("TOPRIGHT", PI.UI.cfg, "TOPRIGHT", -7,15)

	PI.UI.cfg_close:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		PI.UI.cfg_page_dd.ti:SetKeyFocus(false)
		PI.UI.cfg_iset_dd.ti:SetKeyFocus(false)
		PI.UI.cfg:SetVisible(false)
	end, "Event.UI.Input.Mouse.Left.Click")
	
	--print("E>PI.BuildUI()")
end

function PI.Command_Slash_Register(h, args)
	local r = {}
	local numargs = 0
	for token in string.gmatch(args, "[^%s]+") do
		numargs=numargs+1
		r[numargs] = token
	end

	if numargs > 0 then
		if r[1] == "toggle" then
			if PI.UI.c:GetVisible() then
				PI.UI.c:SetVisible(false)
			else
				local sx = UIParent:GetWidth()
				local sy = UIParent:GetHeight()
				local md = Inspect.Mouse()
				local popx = 0
				local popy = 0

				local PISIZE = (PopupItems_Settings.config.ic*3)+8
				local PISIZE2= PISIZE/2

				if md.x < PISIZE2 then
					popx = PISIZE2
				elseif md.x > (sx - PISIZE2) then
					popx = sx - PISIZE2
				else
					popx = md.x
				end

				if md.y < PISIZE2 then
					popy = PISIZE2
				elseif md.y > (sy-PISIZE2) then
					popy = sy - PISIZE2
				else
					popy = md.y
				end

				PI.UI.c:SetPoint("CENTER", UIParent, "TOPLEFT", popx, popy)
				if CURRENT_PAGE == nil then
					PI.SetupPage("DEFAULT")
				end
				PI.UI.c:SetVisible(true)
			end
		elseif r[1] == "size" then
			local sz = tonumber(r[2])
			if sz ~= nil then
				sz = math.floor(sz)
				if sz >= 8 and sz <= 128 then
					PopupItems_Settings.config.ic = sz
					PI.Rescale()
				else
					print("Range for size: 8 .. 128")
				end
			else
				print(sz.." is not a valid size. 8 .. 128")
			end
		elseif r[1] == "reset" then
			PopupItems_Settings = {}
			MergeTable(PopupItems_Settings, default_settings)
		end
	end
end

function PI.LoadPage(p,i)
	if PopupItems_Settings.PAGES[p] == nil then
		print(string.format("Attempted to load page: %s. Does not exist", p))
	else
		local page_dtl
		PI.BUTTONSTATE = { [1] = {err=false, btyp=PI_MENU} }

		if PopupItems_Settings.PAGES[p].type == PIT_QUEST then
			page_dtl = {}
			if PI.QUEST_DETAILS.pageidx[i] ~= nil then
				for x=1, PI.QUEST_DETAILS.pageidx[i].n do
					local idx = x+PI.QUEST_DETAILS.pageidx[i].f-1
					page_dtl[x+1] = { t=PI_ITEM, id=PI.QUEST_DETAILS.items[idx].t, i=PI.QUEST_DETAILS.items[idx].i }
				end
				if i ~= PI.QUEST_DETAILS.pagecnt and PI.QUEST_DETAILS.pagecnt > 0 then
					page_dtl[9] = { t=PI_MENU, n="QUEST", l="Next\nPage" }
				end
			end
			for x = 2,9 do
				if page_dtl[x] == nil then
					page_dtl[x] = { t=PI_NONE }
				end
			end
			qstcrntpage = i
		elseif PopupItems_Settings.PAGES[p].type == PIT_NORMAL then
			page_dtl = PopupItems_Settings.PAGES[p].slots
		end

		_cpitems = {}
		
		for x=2,9 do
			PI.BUTTONSTATE[x] = { item=nil, ityp=nil, btyp=nil, err=false }
			found = false
			PI.UI.f[x].l:SetVisible(false)
			if page_dtl[x] ~= nil and page_dtl[x].t ~= PI_NONE then
				PI.BUTTONSTATE[x].btyp = page_dtl[x].t
				if page_dtl[x].t == PI_ITEM then
					local item_type = page_dtl[x].id
					if _itemdetails[item_type] and _itemdetails[item_type].count > 0 then
						_cpitems[item_type] = true
						PI.BUTTONSTATE[x].ityp = item_type
						PI.UI.f[x].t:SetTexture("Rift", _itemdetails[item_type].icon)
						PI.UI.f[x].t:SetVisible(true)
						PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_empty.png")
						if _itemdetails[item_type].count > 1 then
							PI.UI.f[x].s:SetText(string.format("%d", _itemdetails[item_type].count))
							PI.UI.f[x].s:SetVisible(true)
						else
							PI.UI.f[x].s:SetVisible(false)
						end
					else
						PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_missing.png")
						PI.UI.f[x].t:SetTexture("Rift", PopupItems_Settings.PAGES[p].slots[x].i)
						PI.UI.f[x].l:SetText("No Item\nAvailable")
						PI.UI.f[x].l:SetVisible(true)
						PI.UI.f[x].t:SetVisible(true)
						PI.UI.f[x].s:SetVisible(false)
						PI.BUTTONSTATE[x].err = true
					end
				elseif page_dtl[x].t == PI_MENU then
					PI.UI.f[x].s:SetVisible(false)
					if PopupItems_Settings.PAGES[page_dtl[x].n] ~= nil then
						if PopupItems_Settings.PAGES[page_dtl[x].n].slots ~= nil and #PopupItems_Settings.PAGES[page_dtl[x].n].slots > 0 then
							PI.BUTTONSTATE[x].item = page_dtl[x].n
							PI.BUTTONSTATE[x].ityp = qstcrntpage+1
							if p == "QUEST" then
								PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_next.png")
								PI.UI.f[x].t:SetVisible(false)
							else
								PI.UI.f[x].t:SetVisible(false)
								PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_menu.png")
							end
							if page_dtl[x].l then
								PI.UI.f[x].l:SetText(page_dtl[x].l)
							else
								PI.UI.f[x].l:SetText(string.sub(page_dtl[x].n,1,6))
							end
							PI.UI.f[x].l:SetVisible(true)
						else
							PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_error.png")
							PI.UI.f[x].l:SetText("Empty\nPage")
							PI.UI.f[x].l:SetVisible(true)
							PI.UI.f[x].t:SetVisible(false)
							PI.BUTTONSTATE[x].err = true
						end
					else
						PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_error.png")
						PI.UI.f[x].l:SetText("Invalid\nPage")
						PI.UI.f[x].l:SetVisible(true)
						PI.UI.f[x].t:SetVisible(false)
						PI.BUTTONSTATE[x].err = true
					end					
				elseif page_dtl[x].t == PI_ISET then
					if PopupItems_Settings.ITEM_SETS[page_dtl[x].n] ~= nil then
						if #PopupItems_Settings.ITEM_SETS[page_dtl[x].n].items > 0 then
							found = false
							for k,v in ipairs(PopupItems_Settings.ITEM_SETS[page_dtl[x].n].items) do
								if found==false and _itemdetails[v.id] and _itemdetails[v.id].count > 0 then
									found = true
									_cpitems[v.id] = true
									PI.BUTTONSTATE[x].ityp = v.id
									PI.UI.f[x].t:SetTexture("Rift", _itemdetails[v.id].icon)
									PI.UI.f[x].t:SetVisible(true)
									PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_empty.png")
									if _itemdetails[v.id].count > 1 then
										PI.UI.f[x].s:SetText(string.format("%d", _itemdetails[v.id].count))
										PI.UI.f[x].s:SetVisible(true)
									else
										PI.UI.f[x].s:SetVisible(false)
									end
								end
							end
							if found == false then
								PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_missing.png")
								PI.UI.f[x].t:SetTexture("Rift", PopupItems_Settings.ITEM_SETS[page_dtl[x].n].items[1].i)
								PI.UI.f[x].t:SetVisible(true)
								PI.UI.f[x].l:SetText("No Item\nAvailable")
								PI.UI.f[x].l:SetVisible(true)
								PI.UI.f[x].s:SetVisible(false)
								PI.BUTTONSTATE[x].err = true
							end
						else
							PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_error.png")
							PI.UI.f[x].t:SetVisible(false)
							PI.UI.f[x].l:SetText("Empty\nItemSet")
							PI.UI.f[x].l:SetVisible(true)
							PI.UI.f[x].s:SetVisible(false)
							PI.BUTTONSTATE[x].err = true						
						end
					else
						PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_error.png")
						PI.UI.f[x].l:SetText("Invalid\nItemSet")
						PI.UI.f[x].l:SetVisible(true)
						PI.UI.f[x].t:SetVisible(false)
						PI.UI.f[x].s:SetVisible(false)
						PI.BUTTONSTATE[x].err = true
					end
				end
			else
				PI.BUTTONSTATE[x].btyp = PI_NONE
				PI.UI.f[x].b:SetTexture(addon.identifier, "img/button_empty.png")
				PI.UI.f[x].l:SetVisible(false)
				PI.UI.f[x].t:SetVisible(false)
				PI.UI.f[x].s:SetVisible(false)
			end
		end
	end
end

function PI.SetupPage(p,i)
	if p == nil then
		if CURRENT_PAGE == nil then
			PI.LoadPage("DEFAULT")
			CURRENT_PAGE = "DEFAULT"
		end
	else
		if p ~= CURRENT_PAGE or p=="QUEST" then
			CURRENT_PAGE = p
			if p == "QUEST" then
				PI.LoadPage(p,i)
			else
				PI.LoadPage(p)
			end
		end
	end
	table.insert(PI.MENUSTACK, CURRENT_PAGE)

	if #PI.MENUSTACK == 1 then
		PI.UI.f[1].b:SetTexture(addon.identifier, "img/button_empty.png")
		PI.UI.f[1].t:SetVisible(false)
		PI.UI.f[1].l:SetVisible(false)
	else
		PI.UI.f[1].b:SetTexture(addon.identifier, "img/button_back.png")
		PI.UI.f[1].l:SetText("BACK")
		PI.UI.f[1].l:SetVisible(true)
		PI.UI.f[1].t:SetVisible(true)
	end
end

function PI.Rescale()
	for x=1,9 do
		PI.UI.f[x].b:SetWidth(PopupItems_Settings.config.ic)
		PI.UI.f[x].b:SetHeight(PopupItems_Settings.config.ic)
		PI.UI.f[x].t:SetWidth(math.floor(0.75*PopupItems_Settings.config.ic))
		PI.UI.f[x].t:SetHeight(math.floor(0.75*PopupItems_Settings.config.ic))
		PI.barsize = (PopupItems_Settings.config.ic * 3)+8
	end
end

function PI.cb_libinvCD(t)
	for k,v in pairs(t) do
		_allcooldowns[k] = v.endtime
	end
	CDACTIVE = true
end

function PI.cb_libinvITEM(t)
	local qfound = false
	for it,it_v in pairs(t) do
		if it_v["PLAYER"] then
			local found = false
			local count = 0
			local slotsize = 999999
			local slot = ""
			for sl,cn in pairs(it_v["PLAYER"]) do
				if Library.LibInventory.REFSLOTS.quest[sl] or Library.LibInventory.REFSLOTS.inventory[sl] then
					found = true
					count = count+cn
					if cn <= slotsize then
						slot = sl
						slotsize = cn
					end
				end
			end
			if found then
				if _itemdetails[it] == nil then
					_itemdetails[it] = {count=0, icon=Library.LibInventory.SLOTDETAIL[slot].icon, name=Library.LibInventory.SLOTDETAIL[slot].name, slot=slot}
				end
				_itemdetails[it].count = count
			end
			for _,qd in pairs(PopupItems_Settings.ITEM_SETS.QUEST_ITEMS.items) do
				if qd.id == it then
					qfound = true
				end
			end
			if _cpitems[it] then
				PI.LoadPage(CURRENT_PAGE,1)
			end
		end
	end
	if qfound then
		PI.Event_libZoneChange_Player(0, "", LIBZONECHANGE.currentZoneID)
	end
end

function PI.Event_Addon_SavedVariables_Load_End(h,a)
	if a == addon.identifier then
	
		DD_ISET = {}
		
		if PopupItems_Settings == nil then
			print("Setting up default settings")
			PopupItems_Settings = {}
			MergeTable(PopupItems_Settings, default_settings)
		end
		MergeTable(PopupItems_Settings.config, default_settings.config)
		PopupItems_Settings.config.version = default_settings.config.version
		
		for k,v in pairs(PopupItems_Settings.ITEM_SETS) do
			local f = false
			if v.delete == nil then v.delete = true f = true end
			if v.items == nil then v.items = {} f = true end
			for _,id in pairs(v.items) do
				_registereditems[id.id] = true
			end
			table.insert(DD_ISET, {n=k, i=nil, sk=nil})
			if f then print(string.format("ITEM_SET: %s corrupted. Attempted to fix.", k)) end
		end

		for k,v in pairs(PopupItems_Settings.PAGES) do
			local f = false
			if v.delete == nil then v.delete = true f = true end
			if v.type == nil then v.type = PIT_NORMAL f = true end
			if v.slots == nil then v.slots = {
				nil, {t=PI_NONE},{t=PI_NONE},{t=PI_NONE},{t=PI_NONE},{t=PI_NONE},{t=PI_NONE},{t=PI_NONE},{t=PI_NONE}
			} f = true end
			for _,ps in pairs(v.slots) do
				if ps.t == PI_ITEM then
					_registereditems[ps.id] = true
				end
			end
			if f then print(string.format("PAGE: %s corrupted. Attempted to fix.", k)) end
		end
		
		PI.Rescale()
		PI.UI.cfg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", PopupItems_Settings.config.cfgx,PopupItems_Settings.config.cfgy)
		for k,v in pairs(PopupItems_Settings.ITEM_SETS.QUEST_ITEMS.items) do
			QSTITEMKEY[v.id] = false
		end

		table.sort(DD_ISET, function(a,b) return a.n < b.n end)
		PI.UI.cfg_iset_dd:SetText("Select Itemset...")
		PI.UI.cfg_iset_sel_dd:SetText("Select Itemset...")
		PI.UI.cfg_iset_dd.Update(DD_ISET)
		PI.UI.cfg_iset_sel_dd.Update(DD_ISET)
		
		DD_PAGE = {}
		DD_PAGESEL={}
		for k,v in pairs(PopupItems_Settings.PAGES) do
			if k ~= "QUEST" then
				table.insert(DD_PAGE, {n=k, i=nil, sk=nil})
			end
			table.insert(DD_PAGESEL, {n=k, i=nil, sk=nil})
		end
		table.sort(DD_PAGE, function(a,b) return a.n < b.n end)
		table.sort(DD_PAGESEL, function(a,b) return a.n < b.n end)
		PI.UI.cfg_page_dd:SetText("Select Page...")
		PI.UI.cfg_page_sel_dd:SetText("Select Page...")
		PI.UI.cfg_page_dd.Update(DD_PAGE)
		PI.UI.cfg_page_sel_dd.Update(DD_PAGESEL)

		Library.LibInventory.RegisterItem(_registereditems, PI.cb_libinvITEM)
		Library.LibInventory.Cooldowns(PI.cb_libinvCD)
		LibVersionCheck.register(addon.toc.Identifier, addon.toc.Version)
		--print("E>PI.Event_Addon_SavedVariables_Load_End")
	end
end

local prevCDUpdate = 0

function PI.SetCDText(t)
	for x=2, 9 do
		local it = PI.BUTTONSTATE[x].ityp
		if t[it] then
			PI.UI.f[x].l:SetText(t[it].t)
			PI.UI.f[x].l:SetVisible(t[it].v)
		end
	end	
end

function PI.UpdateCooldowns()
	local tx = Inspect.Time.Real()
	if tx-prevCDUpdate > 0.2 then
		CDACTIVE = false
		local txt = ""
		local upd = false
		local cddx = {}
		for k,v in pairs(_allcooldowns) do
			if tx < v then
				CDACTIVE = true
				if _cpitems[k] then
					local dx = math.ceil(v-tx)
					if dx >= 3600 then
						txt = ">1hr"
					elseif dx > 300 then
						txt=STRINGFORMAT("%dm", dx/60)
					else
						local m = math.floor(dx/60)
						local s = dx-(m*60)
						txt=STRINGFORMAT("%d:%02d", m,s)
					end
					cddx[k] = {t=txt, v=true}
					upd = true
				end
			else
				_allcooldowns[k] = nil
				if _cpitems[k] then
					cddx[k] = {t="N/A", v=false}
					upd = true
				end
			end
		end
		if upd then
			PI.SetCDText(cddx)
		end
		prevCDUpdate = tx
	end
end

function PI.UpdateHandler()
	while true do
		if CDACTIVE then
			PI.UpdateCooldowns()
		end
		coroutine.yield()
	end
end

PI.coUpdateHandler = coroutine.create(PI.UpdateHandler)

function PI.Event_System_Update_Begin(h)
	if coroDead then return end
	local ok, errormsg = coroutine.resume(PI.coUpdateHandler)
	if not ok then
		coroDead = true
		error("Error in coroutine: "..errormsg)
	end
end

function PI.Event_libZoneChange_Player(h, zn, zid)
	PI.QUEST_DETAILS.zone = zid
	PI.QUEST_DETAILS.page = 1
	PI.QUEST_DETAILS.pageidx = {}
	PI.QUEST_DETAILS.pagecnt = 1
	PI.QUEST_DETAILS.finalpg = 1
	PI.QUEST_DETAILS.finalty = 0
	PI.QUEST_DETAILS.zone = zid
	PI.QUEST_DETAILS.items = {}

	for k,v in ipairs(PopupItems_Settings.ITEM_SETS.QUEST_ITEMS.items) do
		if _itemdetails[v.id] and _itemdetails[v.id].count > 0 then
			if v.z == LIBZONECHANGE.currentZoneID then
				table.insert(PI.QUEST_DETAILS.items, 1, {t=v.id, i=v.i})
			else
				table.insert(PI.QUEST_DETAILS.items, {t=v.id, i=v.i})
			end
		end
	end

	local a,b = math.modf(#PI.QUEST_DETAILS.items/7)
	b = #PI.QUEST_DETAILS.items-(a*7)
	if b == 0 and a>0 then
		PI.QUEST_DETAILS.pagecnt = a
		PI.QUEST_DETAILS.finalpg = 7
	elseif b==1 and a>0 then
		PI.QUEST_DETAILS.pagecnt = a
		PI.QUEST_DETAILS.finalpg = 8
	else
		PI.QUEST_DETAILS.pagecnt = a+1
		PI.QUEST_DETAILS.finalpg = b
	end

	for x=1, PI.QUEST_DETAILS.pagecnt-1 do
		table.insert(PI.QUEST_DETAILS.pageidx, {f=(x*7)-6, l=(x*7), n=7})
	end
	table.insert(PI.QUEST_DETAILS.pageidx, {f=(PI.QUEST_DETAILS.pagecnt*7)-6, l=(PI.QUEST_DETAILS.pagecnt*7)-7+PI.QUEST_DETAILS.finalpg, n=PI.QUEST_DETAILS.finalpg})

	while(PI.MENUSTACK[#PI.MENUSTACK] == "QUEST") do
		table.remove(PI.MENUSTACK, #PI.MENUSTACK)
	end
	if CURRENT_PAGE == "QUEST" then
		table.insert(PI.MENUSTACK, "QUEST")
		PI.LoadPage("QUEST",1)
	end
end

PI.BuildUI()

Command.Event.Attach(Command.Slash.Register("pi"), PI.Command_Slash_Register, "Command.Slash.Register")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, PI.Event_Addon_SavedVariables_Load_End, "Event.Addon.SavedVariables.Load.End")
Command.Event.Attach(Event.System.Update.Begin, PI.Event_System_Update_Begin, "Event.System.Update.Begin")
Command.Event.Attach(Library.libZoneChange.Player, PI.Event_libZoneChange_Player, "Library.LibZoneChange.Player")

print(string.format("v%s loaded.", addon.toc.Version))
